Bug 173543 - net/ucarp / vlan interfaces
Summary: net/ucarp / vlan interfaces
Status: Closed FIXED
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s) (show other bugs)
Version: Latest
Hardware: Any Any
: Normal Affects Only Me
Assignee: Stefan Walter
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2012-11-11 01:10 UTC by Ingo Flaschberger
Modified: 2013-04-28 23:40 UTC (History)
0 users

See Also:


Attachments
file.diff (661 bytes, patch)
2012-11-11 01:10 UTC, Ingo Flaschberger
no flags Details | Diff
ucarp-1.5.2_2.diff (6.04 KB, patch)
2013-02-06 17:12 UTC, Alexey Degtyarev
no flags Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Ingo Flaschberger freebsd_committer 2012-11-11 01:10:00 UTC
Using ucarp with a vlan interface results in followring problem:
[ERROR] Invalid media / hardware address for [vlan10]
[ERROR] Unable to find MAC address of [vlan10]

Fix: Patch attached with submission follows:
Comment 1 Edwin Groothuis freebsd_committer 2013-01-20 02:23:59 UTC
State Changed
From-To: open->feedback

Awaiting maintainers feedback (via the GNATS Auto Assign Tool)
Comment 2 Edwin Groothuis freebsd_committer 2013-01-20 02:23:59 UTC
Maintainer of net/ucarp,

Please note that PR ports/173543 has just been submitted.

If it contains a patch for an upgrade, an enhancement or a bug fix
you agree on, reply to this email stating that you approve the patch
and a committer will take care of it.

The full text of the PR can be found at:
    http://www.freebsd.org/cgi/query-pr.cgi?pr=ports/173543

-- 
Edwin Groothuis via the GNATS Auto Assign Tool
edwin@FreeBSD.org
Comment 3 Alexey Degtyarev 2013-02-06 17:12:31 UTC
Thanks!

The attached patch to net/ucarp to be committed.

Changes with 1.5.2_2:

* Fix error with VLAN interfaces on recent FreeBSD versions;
  (thanks to Ingo Flaschberger <if@FreeBSD.org>)

* Update port's infrastructure to new OPTIONS;

* Make portlint happy with filenames in "files/";


-- 
Alexey V. Degtyarev
Comment 4 Stefan Walter freebsd_committer 2013-04-28 23:12:48 UTC
Responsible Changed
From-To: freebsd-ports-bugs->stefan

Take.
Comment 5 dfilter service freebsd_committer 2013-04-28 23:31:46 UTC
Author: stefan
Date: Sun Apr 28 22:31:32 2013
New Revision: 316763
URL: http://svnweb.freebsd.org/changeset/ports/316763

Log:
  - Fix error with VLAN interfaces on recent FreeBSD versions [1]
  - Update port's infrastructure to new OPTIONS [2]
  - Make portlint happy with filenames in "files/" [2]
  
  PR:		173543
  Submitted by:	Ingo Flaschberger <if@FreeBSD.org>
  Patch by:	Ingo Flaschberger <if@FreeBSD.org> [1]
  		"Alexey V. Degtyarev" <alexey@renatasystems.org> (maintainer) [2]

Added:
  head/net/ucarp/files/patch-l2vlan   (contents, props changed)
  head/net/ucarp/files/patch-vip-down   (contents, props changed)
  head/net/ucarp/files/patch-vip-up   (contents, props changed)
Deleted:
  head/net/ucarp/files/patch-examples:bsd:vip-down.sh
  head/net/ucarp/files/patch-examples:bsd:vip-up.sh
Modified:
  head/net/ucarp/Makefile   (contents, props changed)

Modified: head/net/ucarp/Makefile
==============================================================================
--- head/net/ucarp/Makefile	Sun Apr 28 22:30:41 2013	(r316762)
+++ head/net/ucarp/Makefile	Sun Apr 28 22:31:32 2013	(r316763)
@@ -1,13 +1,9 @@
-# New ports collection makefile for:   ucarp
-# Date created:                2005-05-06
-# Whom:                        Meno Abels <meno.abels@adviser.com>
-#
+# Created by: Meno Abels <meno.abels@adviser.com>
 # $FreeBSD$
-#
 
 PORTNAME=	ucarp
 PORTVERSION=	1.5.2
-PORTREVISION=	1
+PORTREVISION=	2
 CATEGORIES=	net
 MASTER_SITES=	ftp://ftp.pureftpd.org/pub/pure-ftpd/misc/ucarp/ \
 		http://download.pureftpd.org/pub/ucarp/
@@ -17,9 +13,12 @@ COMMENT=	Userlevel Common Address Redund
 
 USE_BZIP2=	yes
 
-OPTIONS=	UCARP_SCRIPTS "Install scripts to manage virtual IP" on
+OPTIONS_DEFINE=	SCRIPTS
+OPTIONS_DEFAULT=SCRIPTS
 
-.include <bsd.port.pre.mk>
+SCRIPTS_DESC=	Install scripts to manage virtual IP
+
+.include <bsd.port.options.mk>
 
 GNU_CONFIGURE=	yes
 CONFIGURE_ARGS=	--disable-nls
@@ -28,7 +27,7 @@ USE_RC_SUBR=	ucarp
 
 PLIST_FILES=	sbin/ucarp
 
-.if defined(WITH_UCARP_SCRIPTS)
+.if ${PORT_OPTIONS:MSCRIPTS}
 PLIST_FILES+=	sbin/ucarp-up \
 		sbin/ucarp-down
 post-install:
@@ -36,4 +35,4 @@ post-install:
 		${INSTALL_SCRIPT} ${WRKSRC}/examples/bsd/vip-down.sh ${PREFIX}/sbin/ucarp-down
 .endif
 
-.include <bsd.port.post.mk>
+.include <bsd.port.mk>

Added: head/net/ucarp/files/patch-l2vlan
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ head/net/ucarp/files/patch-l2vlan	Sun Apr 28 22:31:32 2013	(r316763)
@@ -0,0 +1,14 @@
+# http://www.freebsd.org/cgi/query-pr.cgi?pr=ports/164060
+# http://www.freebsd.org/cgi/query-pr.cgi?pr=ports/173543
+--- src/fillmac.c.orig	2007-07-04 15:34:59.000000000 +0200
++++ src/fillmac.c	2012-11-11 01:50:29.000000000 +0100
+@@ -86,7 +86,8 @@
+             if (strcmp(ifa->ifa_name, interface) == 0 &&
+                 ifa->ifa_addr->sa_family == AF_LINK) {
+                 sadl = (struct sockaddr_dl *) ifa->ifa_addr;
+-                if (sadl == NULL || sadl->sdl_type != IFT_ETHER ||
++                if (sadl == NULL || ((sadl->sdl_type != IFT_ETHER) && 
++                    (sadl->sdl_type != IFT_L2VLAN)) ||
+                     sadl->sdl_alen <= 0) {
+                     logfile(LOG_ERR,
+                             _("Invalid media / hardware address for [%s]"),

Added: head/net/ucarp/files/patch-vip-down
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ head/net/ucarp/files/patch-vip-down	Sun Apr 28 22:31:32 2013	(r316763)
@@ -0,0 +1,24 @@
+--- examples/bsd/vip-down.sh.orig	2006-05-27 20:38:40.000000000 +0000
++++ examples/bsd/vip-down.sh	2010-05-30 20:40:19.000000000 +0000
+@@ -1,4 +1,21 @@
+ #! /bin/sh
++
++if [ -z "$1" -o -z "$2" ]; then
++	cat <<EOF
++Usage: ${0##*/} interface virtual-address [if-keep-ip]
++  interface        - interface name where virtual IP-address to be assigned;
++  virtual-address  - virtual IP-address;
++  if-keep-ip       - interface name where virtual IP-address should be kept
++                     when ucarp changes state to BACKUP;
++
++EOF
++	exit 255
++fi
++
+ exec 2> /dev/null
+ 
+ /sbin/ifconfig "$1" -alias "$2"
++
++if [ ! -z "$3" ]; then
++	/sbin/ifconfig "$3" alias "$2" netmask 255.255.255.255
++fi

Added: head/net/ucarp/files/patch-vip-up
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ head/net/ucarp/files/patch-vip-up	Sun Apr 28 22:31:32 2013	(r316763)
@@ -0,0 +1,24 @@
+--- examples/bsd/vip-up.sh.orig	2006-05-27 20:38:34.000000000 +0000
++++ examples/bsd/vip-up.sh	2010-05-30 20:40:19.000000000 +0000
+@@ -1,4 +1,21 @@
+ #! /bin/sh
++
++if [ -z "$1" -o -z "$2" ]; then
++	cat <<EOF
++Usage: ${0##*/} interface virtual-address [if-keep-ip]
++  interface        - interface name where virtual IP-address to be assigned;
++  virtual-address  - virtual IP-address;
++  if-keep-ip       - interface name where virtual IP-address should be kept
++                     when ucarp changes state to BACKUP;
++
++EOF
++	exit 255
++fi
++
+ exec 2> /dev/null
+ 
++if [ ! -z "$3" ]; then
++	/sbin/ifconfig "$3" -alias "$2"
++fi
++
+ /sbin/ifconfig "$1" alias "$2" netmask 255.255.255.255
_______________________________________________
svn-ports-all@freebsd.org mailing list
http://lists.freebsd.org/mailman/listinfo/svn-ports-all
To unsubscribe, send any mail to "svn-ports-all-unsubscribe@freebsd.org"
Comment 6 Stefan Walter freebsd_committer 2013-04-28 23:35:27 UTC
State Changed
From-To: feedback->closed

Patch has been committed, thanks!